' ********************************************************************************************************
' LB79 TDL Manager v1.1
' LB79 RemoveNote.vbs

' This script will remove a bullet-point and note from the specified text file.  You can specify the text
' file you wish to use by changing the "SelectedDataPath" field as required (see LINE 42)
' ********************************************************************************************************

set WSHShell = CreateObject("Wscript.Shell")
set FSO = CreateObject("Scripting.FileSystemObject")

SamurizePath = WSHShell.RegRead("HKEY_CURRENT_USER\Software\Serious Samurize\General\DirPath")

Input = Trim(InputBox("Which note would you like to remove?", "LB79 TDL Manager | Remove Note"))

LineNum = 0
Set RegEx = New RegExp
RegEx.Pattern = "^\d+\b"
if RegEx.Test(Input) then 
   Set Matches = RegEx.Execute(Input)
   if (Matches.Count = 1) then
      set Match = Matches(0)
      LineNum = Match.Value
   end if
else
   if (Len(Input) > 0) then
      result = MsgBox("Cannot remove note #" & Input & "." & (Chr(13) & Chr(10)) & (Chr(13) & Chr(10)) & Chr(34) & Input & Chr(34) & " is not a valid note number.", vbExclamation, "LB79 TDL Manager | Error")
   end if
end if

Continue = TRUE

if (LineNum = 0) then
   Continue = FALSE
else
   LineNum = Int(LineNum)
end if

' test notes file exists, that its not empty, meanwhile count number of lines
if (Continue = TRUE) then

'Change the quoted path to suit your needs.
	SelectedDataPath = SamurizePath&"Scripts\LB79 TDL Manager v1.1\LB79 TDL File - Other01.txt"

	NumLines = 0
   if (FSO.FileExists(SelectedDataPath)) then
      set ThisTextFile = FSO.GetFile(SelectedDataPath)
      Filename = ThisTextFile.Name

      if (ThisTextFile.Size) then
         set TextFileData = FSO.OpenTextFile(SelectedDataPath)

         do while (TextFileData.AtEndOfStream = FALSE)
            TextFileData.ReadLine
            NumLines = NumLines + 1
         loop

         TextFileData.Close
      else
         result = MsgBox("Cannot remove note." & (Chr(13) & Chr(10)) & (Chr(13) & Chr(10)) & "No notes to delete.", vbExclamation, "LB79 TDL Manager | Error")
	    Continue = FALSE
      end if
   else
      result = MsgBox("Cannot remove note." & (Chr(13) & Chr(10)) & (Chr(13) & Chr(10)) & "The text file could not be found at:" & (Chr(13) & Chr(10)) & SelectedDataPath, vbExclamation, "LB79 TDL Manager | Error")
      Continue = FALSE
   end if
end if

'test input is within range of valid line numbers
if (Continue = TRUE) then
   if (LineNum > NumLines) then
      result = MsgBox("Cannot remove note #" & Input & "." & (Chr(13) & Chr(10)) & (Chr(13) & Chr(10)) & Chr(34) & Input & Chr(34) & " is not a valid note number.", vbExclamation, "LB79 TDL Manager | Error")
      Continue = FALSE
   end if
end if

'load notes file, skipping entered line number, then save/refresh/exit
if (Continue = TRUE) then
   set TextFileData = FSO.OpenTextFile(SelectedDataPath)

   TempDataPath = SamurizePath&"Scripts\LB79 TDL Manager v1.1\LB79 TDL Manager Data.000"

   set TempData = FSO.CreateTextFile(TempDataPath)

   CurrLineNum = 0
   do while (TextFileData.AtEndOfStream = FALSE)
      CurrLineNum = CurrLineNum + 1     
      if (CurrLineNum = LineNum) then
         TextFileData.SkipLine
      else
         Line = TextFileData.ReadLine
         TempData.Write(Line & vbCrLf)
      end if
   loop

   TextFileData.Close
   TempData.Close

   ThisTextFile.Delete

   set ThisTextFile = FSO.GetFile(TempDataPath)
   ThisTextFile.Name = Filename

   WSHShell.SendKeys "^%r"
end if
